from fastapi import APIRouter, Depends
from kv.database import get_db
import isjkhrs.crud as crud
from sqlalchemy.orm import Session
from typing import List
import isjkhrs.schemas as schemas

router = APIRouter()

@router.post('/get_filter_types', response_model=List[schemas.FilterTypeSerializer])
async def get_filter_types(request: schemas.FilterTypeInit, db: Session = Depends(get_db)):
    return crud.FilterViewSet.get_filter_types(db, request)


@router.post('/get_filter_list', response_model=List[schemas.FilterListSerializer])
async def get_filter_list(request: schemas.FilterListInit, db: Session = Depends(get_db)):
    return crud.FilterViewSet.get_filter_list(db, request)


@router.post('/set_report_filter_list', response_model=List[schemas.FilterListSerializer])
async def set_report_filter_list(request: schemas.FilterSetInit, db: Session = Depends(get_db)):
    return crud.FilterViewSet.set_filter_list(db, request)